/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/****  Project : eXtended C Library (XCLIB)
    *  Purpose : INTEGER TYPES
    *  Language: ANSI C
    *  File    : demo_ints.c
    *  Author  : Martin Vicente <martin@vicente.org>
    *
    ****/


#include <limits.h>
#include <stdio.h>

#include <xc/ints.h>

#define NbBitsOf(type)	((unsigned long int)(CHAR_BIT * sizeof  (type)))

int main()
{
    printf("nb of bits of  int8  = %lu\n", NbBitsOf  (int8));
    printf("nb of bits of uint8  = %lu\n", NbBitsOf (uint8));
    printf("nb of bits of bits8  = %lu\n", NbBitsOf (bits8));
    printf("nb of bits of  int16 = %lu\n", NbBitsOf  (int16));
    printf("nb of bits of uint16 = %lu\n", NbBitsOf (uint16));
    printf("nb of bits of bits16 = %lu\n", NbBitsOf (bits16));
    printf("nb of bits of  int32 = %lu\n", NbBitsOf  (int32));
    printf("nb of bits of uint32 = %lu\n", NbBitsOf (uint32));
    printf("nb of bits of bits32 = %lu\n", NbBitsOf (bits32));
#ifdef  int64
    printf("nb of bits of  int64 = %lu\n", NbBitsOf  (int64));
#endif
#ifdef uint64
    printf("nb of bits of uint64 = %lu\n", NbBitsOf (uint64));
#endif
#ifdef bits64
    printf("nb of bits of bits64 = %lu\n", NbBitsOf (bits64));
#endif

    return 0;
}


/* End of file */
