/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	MATH:		EXTRA MATHEMATIC FUNCTIONS		     */


/*  !!! WARNING !!!    E X P E R I M E N T A L    !!! WARNING !!!  */


#ifndef __XC_MATH_H
#define __XC_MATH_H


#ifndef __EXPERIMENTAL__
#warning "<xc/math.h> is experimental"
#endif


/* eXtended C Library: */
#include <xc/cdecl.h>		/* C DECLARATIONS			     */


#if defined _XCLIB_SOURCE || defined _XC_MATH_SOURCE

#define add(table, count)	math_add(table, count)
#define mul(table, count)	math_mul(table, count)
#define ipow(x, y)		math_ipow(x, y)
#define iipow(x, y)		math_iipow(x, y)
#define iatan2(y, x)		math_iatan2(y, x)

#define ladd(table, count)	math_ladd(table, count)
#define lmul(table, count)	math_lmul(table, count)
#define ipowl(x, y)		math_ipowl(x, y)
#define iipowl(x, y)		math_iipowl(x, y)
#define iatan2l(y, x)		math_iatan2l(y, x)

#if defined __GNUC__ && !defined __STRICT_ANSI__
#define lladd(table, count)	math_lladd(table, count)
#define llmul(table, count)	math_llmul(table, count)
#define ipowll(x, y)		math_ipowll(x, y)
#define iipowll(x, y)		math_iipowll(x, y)
#define iatan2ll(y, x)		math_iatan2ll(y, x)
#endif

#define faddf(table, count)	math_faddf(table, count)
#define fmulf(table, count)	math_fmulf(table, count)

#define fadd(table, count)	math_fadd(table, count)
#define fmul(table, count)	math_fmul(table, count)

#define faddl(table, count)	math_faddl(table, count)
#define fmull(table, count)	math_fmull(table, count)

#endif


#define math_add(table, count)		__xclib(math_add)(table, count)
#define math_mul(table, count)		__xclib(math_mul)(table, count)
#define math_ipow(x, y)			__xclib(math_ipow)(x, y)
#define math_iipow(x, y)		__xclib(math_iipow)(x, y)
#define math_iatan2(y, x)		__xclib(math_iatan2)(y, x)

#define math_ladd(table, count)		__xclib(math_ladd)(table, count)
#define math_lmul(table, count)		__xclib(math_lmul)(table, count)
#define math_ipowl(x, y)		__xclib(math_ipowl)(x, y)
#define math_iipowl(x, y)		__xclib(math_iipowl)(x, y)
#define math_iatan2l(y, x)		__xclib(math_iatan2l)(y, x)

#if defined __GNUC__ && !defined __STRICT_ANSI__
#define math_lladd(table, count)	__xclib(math_lladd)(table, count)
#define math_llmul(table, count)	__xclib(math_llmul)(table, count)
#define math_ipowll(x, y)		__xclib(math_ipowll)(x, y)
#define math_iipowll(x, y)		__xclib(math_iipowll)(x, y)
#define math_iatan2ll(y, x)		__xclib(math_iatan2ll)(y, x)
#endif

#define math_faddf(table, count)	__xclib(math_faddf)(table, count)
#define math_fmulf(table, count)	__xclib(math_fmulf)(table, count)

#define math_fadd(table, count)		__xclib(math_fadd)(table, count)
#define math_fmul(table, count)		__xclib(math_fmul)(table, count)

#define math_faddl(table, count)	__xclib(math_faddl)(table, count)
#define math_fmull(table, count)	__xclib(math_fmull)(table, count)


_CDECL_BEGIN

#define	__N unsigned int

#define	__T int
__T    __xclib(math_add)(__T table[], __N count);
__T    __xclib(math_mul)(__T table[], __N count);
double __xclib(math_ipow)(double x, __T y);
__T    __xclib(math_iipow)(__T x, __T y);
__T    __xclib(math_iatan2)(__T y, __T x);
#undef	__T

#define	__T long int
__T    __xclib(math_ladd)(__T table[], __N count);
__T    __xclib(math_lmul)(__T table[], __N count);
double __xclib(math_ipowl)(double x, __T y);
__T    __xclib(math_iipowl)(__T x, __T y);
__T    __xclib(math_iatan2l)(__T y, __T x);
#undef	__T

#if defined __GNUC__ && !defined __STRICT_ANSI__

#define	__T long long int
__T    __xclib(math_lladd)(__T table[], __N count);
__T    __xclib(math_llmul)(__T table[], __N count);
double __xclib(math_ipowll)(double x, __T y);
__T    __xclib(math_iipowll)(__T x, __T y);
__T    __xclib(math_iatan2ll)(__T y, __T x);
#undef	__T

#endif

#define	__T float
__T __xclib(math_faddf)(__T table[], __N count);
__T __xclib(math_fmulf)(__T table[], __N count);
#undef	__T

#define	__T double
__T __xclib(math_fadd)(__T table[], __N count);
__T __xclib(math_fmul)(__T table[], __N count);
#undef	__T

#define	__T long double
__T __xclib(math_faddl)(__T table[], __N count);
__T __xclib(math_fmull)(__T table[], __N count);
#undef	__T

#undef	__N

_CDECL_END


enum
{
    _mathFast            = (1 << 0),
    _mathBestAlgorithm   = (1 << 1),
    _mathNoRangeChecking = (1 << 2)
};

#define _math_flags	__xclib(_math_flags)

extern unsigned int __xclib(_math_flags);


#endif /* XC MATH HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
