/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : SOME COMMON ERRORS
  | Version : 0.3
  | Language: ANSI C
  | File    : errors/errors.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#define _XCLIB_INTERNALS

#include "xc/errors.h"

#include "global.h"

GLOBAL const char err_success[] = ERR_SUCCESS;
GLOBAL const char err_failure[] = ERR_FAILURE;
GLOBAL const char err_memfull[] = ERR_MEMFULL;
GLOBAL const char err_sysfail[] = ERR_SYSFAIL;
GLOBAL const char err_cliberr[] = ERR_CLIBERR;
GLOBAL const char err_norange[] = ERR_NORANGE;
GLOBAL const char err_convert[] = ERR_CONVERT;
GLOBAL const char err_ioerror[] = ERR_IOERROR;
GLOBAL const char err_network[] = ERR_NETWORK;
GLOBAL const char err_display[] = ERR_DISPLAY;
GLOBAL const char err_xwindow[] = ERR_XWINDOW;
GLOBAL const char err_invalid[] = ERR_INVALID;
GLOBAL const char err_program[] = ERR_PROGRAM;
GLOBAL const char err_cassert[] = ERR_CASSERT;
GLOBAL const char err_maxargs[] = ERR_MAXARGS;


/* End Of File */
