#include <stddef.h>
#include <stdio.h>
#include <assert.h>

#include "xc/LList.h"
#include "xc/xalloc.h"

struct node
{
    struct node *next;
    struct node *prev;

    int data;
};

struct list
{
    struct node *head;
    struct node *tail;
};

static void print(struct list *list);

int main()
{
    struct list *list;
    struct node *node1;
    struct node *node2;
    struct node *node3;
    struct node *node4;
    struct node *node5;

    list = xnewrec(struct list);
    _LL_INIT(list->head, list->tail);
    print(list);

    (node1 = xnewrec(struct node))->data = 1;
    _LL_APPEND(list->head, list->tail, node1);
    print(list);

    (node2 = xnewrec(struct node))->data = 2;
    _LL_APPEND(list->head, list->tail, node2);
    print(list);

    (node3 = xnewrec(struct node))->data = 3;
    _LL_APPEND(list->head, list->tail, node3);
    print(list);

    (node4 = xnewrec(struct node))->data = 4;
    _LL_INSERT(list->head, list->tail, node4);
    print(list);

    (node5 = xnewrec(struct node))->data = 5;
    _LL_INSERT(list->head, list->tail, node5);
    print(list);

    _LL_REMOVE(list->head, list->tail, node5);
    xfree(node5);
    print(list);

    _LL_REMOVE(list->head, list->tail, node3);
    xfree(node3);
    print(list);

    _LL_ACTION(list->head, list->tail, xfree(__node););
    xfree(list);

    return 0;
}

static void print(struct list *list)
{
    assert(list != NULL);

    fputs("List: (", stdout);

    _LL_FOREACH_NODE(list->head, list->tail,
    {
	printf(" %d", __node->data);
    });

    puts(" )");
}
