############################################################## -*- makefile -*-
#
#	Copyright (C) 1996-2001  Martin Vicente
#	This file is part of the eXtended C Library (XCLIB).
#
#	This library is free software; you can redistribute it and/or
#	modify it under the terms of the GNU Library General Public
#	License as published by the Free Software Foundation; either
#	version 2 of the License, or (at your option) any later version.
#
#	This library is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#	Library General Public License for more details.
#
#	You should have received a copy of the GNU Library General Public
#	License along with this library (see the file COPYING.LIB).
#	If not, write to the Free Software Foundation, Inc.,
#	59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#
###############################################################################
#
#	HELP-COLORS TARGET
#
# Warning: This is an include file for GNU makefiles only.
#
#	Project : "Les outils de Martin"
#	Purpose : `help-colors' target for GNU makefile
#	File    : utils/help-colors.mk
#	Version : 1.1
#	Language: GNU Make
#	Author  : Martin Vicente
#	Contact : martin@vicente.org (or martin.vicente@free.fr)
#	Revision: Mon, 14 May 2001
#
###############################################################################

ifneq (,)
This makefile requires GNU Make.
endif

ifndef   __UTILS_HELP_COLORS_MK
override __UTILS_HELP_COLORS_MK := OK

#==============================================================================

override UTILS ?= $(HOME)/devel/utils

include $(UTILS)/color.mk		# DISPLAY COLORIZATION

#====( DEFINITIONS )

      ifeq ($(SYSNAME), Linux)
override COLORS := Red Green Yellow Blue Magenta Cyan
      else
override COLORS := red green yellow blue magenta cyan
      endif

override _1 := "Environment:"
override _2 :=
override _3 := "    COLOR    = 0/False/No/Yes/COLOR-NAME"
override _4 := "    BG_COLOR = 0/False/No/Yes/COLOR-NAME"
override _5 := 
override _6 := "    COLOR-NAME is one of:"
override _7 :=
      ifeq ($(SYSNAME), Linux)
override _8 := "      "$(call Bold,\
$(call BgWhite, " "$(call Black, Black)" ")\
$(foreach c, $(COLORS), $(call $c, $c))\
$(call BgBlack, " "$(call White, White)" "))
      else
override _8 := "      "$(bold)\
$(bg_white)" "$(black)black$(default)" "$(bg_default)\
$(foreach c, $(COLORS), $($c)$c$(default))\
$(bg_black)" "$(white)white$(default)" "$(bg_default)$(bold_off)
      endif


override count := 1 2 3 4 5 6 7 8

override HELP_COLORS := $(foreach n, $(count), $(_$n)\\n)

#====( RULES )

help-colors: usage ; @ $(ECHO_E) $(green)$(HELP_COLORS)$(reset)

.PHONY: help-colors

#==============================================================================

endif  # __UTILS_HELP_COLORS_MK

# [END OF FILE]
